/**
  ******************************************************************************
  * @file    vk2c21.h 
  * @author  kevin_guo
  * @version V1.2
  * @date    05-17-2020
  * @brief   Header files for Vk2c21
  ******************************************************************************
  * @attention
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __VK2c21_H
#define __VK2c21_H

/* Includes ------------------------------------------------------------------*/
//˰ļݿͻƬӦ޸
#include "M451Series.h"
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported define -----------------------------------------------------------*/
#define Vk2c21_ADDR   			0x70    // IICַ
//
#define Vk2c21_RWRAM				0x80    // дʾRAM
#define Vk2c21_MODESET		  0x82    // BIAS,COM
	#define CCOM_1_3__4 			0x00  	// 1/3bias 4com
	#define CCOM_1_4__4 			0x01  	// 1/4bias 4com
	#define CCOM_1_3__8 			0x02  	// 1/3bias 8com
	#define CCOM_1_4__8 			0x03  	// 1/4bias 8com
#define Vk2c21_SYSSET				0x84    // IRC,LCD
	#define SYSOFF_LCDOFF  		0x00  	// IRC off,LCD off
	#define SYSON_LCDOFF  		0x02  	// IRC on,LCD off
	#define SYSON_LCDON  			0x03  	// IRC on,LCD on
#define Vk2c21_FRAMESET			0x86    // ֡Ƶ
	#define FRAME_80HZ  			0x00  	// ֡Ƶ80HZ
	#define FRAME_160HZ  			0x01  	// ֡Ƶ160HZ
#define Vk2c21_BLINKSET			0x88    // ˸Ƶ
	#define BLINK_OFF  				0x00  	// ˸ر
	#define BLINK_2HZ  				0x01  	// ˸2HZ
	#define BLINK_1HZ  				0x02  	// ˸1HZ
	#define BLINK_0D5HZ  			0x03  	// ˸0.5HZ
#define Vk2c21_IVASET				0x8A    // SEG/VLCDýúڲѹ
	#define VLCDSEL_IVAOFF_R0 0x00  	// SEG/VLCDýΪVLCDڲѹܹر,VLCDVDD̽VR=0ƫõѹ=VDD
	#define VLCDSEL_IVAOFF_R1 0x0F  	// SEG/VLCDýΪVLCDڲѹܹر,VLCDVDDӵVR>0ƫõѹ=VLCD
	
	#define VLCDSEL_IVA00H 		0x10  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=VDD 			1/4bias=VDD
	#define VLCDSEL_IVA01H 		0x11  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.944VDD 1/4bias=0.957VDD
	#define VLCDSEL_IVA02H 		0x12  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.894VDD 1/4bias=0.918VDD
	#define VLCDSEL_IVA03H 		0x13  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.849VDD 1/4bias=0.882VDD
	#define VLCDSEL_IVA04H 		0x14  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.808VDD 1/4bias=0.849VDD
	#define VLCDSEL_IVA05H 		0x15  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.771VDD 1/4bias=0.818VDD
	#define VLCDSEL_IVA06H 		0x16  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.738VDD 1/4bias=0.789VDD
	#define VLCDSEL_IVA07H 		0x17  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.707VDD 1/4bias=0.763VDD
	#define VLCDSEL_IVA08H 		0x18  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.678VDD 1/4bias=0.738VDD
	#define VLCDSEL_IVA09H 		0x19  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.652VDD 1/4bias=0.714VDD
	#define VLCDSEL_IVA0AH 		0x1A  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.628VDD 1/4bias=0.692VDD
	#define VLCDSEL_IVA0BH 		0x1B  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.605VDD 1/4bias=0.672VDD
	#define VLCDSEL_IVA0CH 		0x1C  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.584VDD 1/4bias=0.652VDD
	#define VLCDSEL_IVA0DH 		0x1D  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.565VDD 1/4bias=0.634VDD
	#define VLCDSEL_IVA0EH 		0x1E  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.547VDD 1/4bias=0.616VDD
	#define VLCDSEL_IVA0FH 		0x1F  	// SEG/VLCDýΪVLCDڲƫõѹ1/3bias=0.529VDD 1/4bias=0.600VDD
	
	#define SEGSEL_IVAOFF			0x20  	// SEG/VLCDýΪSEGڲѹܹر,VDDṩƫõѹ
	#define SEGSEL_IVA00H 		0x30  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=VDD 			1/4bias=VDD
	#define SEGSEL_IVA01H 		0x31  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.944VDD 1/4bias=0.957VDD
	#define SEGSEL_IVA02H 		0x32  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.894VDD 1/4bias=0.918VDD
	#define SEGSEL_IVA03H 		0x33  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.849VDD 1/4bias=0.882VDD
	#define SEGSEL_IVA04H 		0x34  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.808VDD 1/4bias=0.849VDD
	#define SEGSEL_IVA05H 		0x35  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.771VDD 1/4bias=0.818VDD
	#define SEGSEL_IVA06H 		0x36  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.738VDD 1/4bias=0.789VDD
	#define SEGSEL_IVA07H 		0x37  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.707VDD 1/4bias=0.763VDD
	#define SEGSEL_IVA08H 		0x38  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.678VDD 1/4bias=0.738VDD
	#define SEGSEL_IVA09H 		0x39  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.652VDD 1/4bias=0.714VDD
	#define SEGSEL_IVA0AH 		0x3A  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.628VDD 1/4bias=0.692VDD
	#define SEGSEL_IVA0BH 		0x3B  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.605VDD 1/4bias=0.672VDD
	#define SEGSEL_IVA0CH 		0x3C  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.584VDD 1/4bias=0.652VDD
	#define SEGSEL_IVA0DH 		0x3D  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.565VDD 1/4bias=0.634VDD
	#define SEGSEL_IVA0EH 		0x3E  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.547VDD 1/4bias=0.616VDD
	#define SEGSEL_IVA0FH 		0x3F  	// SEG/VLCDýΪSEGڲƫõѹ1/3bias=0.529VDD 1/4bias=0.600VDD	

//seg
//4com 
//VK2C21A/B/C/D
#define 	Vk2c21_SEGNUM					20
#define 	Vk2c21A_MAXSEGNUM			20
#define 	Vk2c21B_MAXSEGNUM			16
#define 	Vk2c21C_MAXSEGNUM			12
#define 	Vk2c21D_MAXSEGNUM			8
//8com
//VK2C21A/B/C/D
//#define 	Vk2c21_SEGNUM					16
//#define 	Vk2c21A_MAXSEGNUM			16
//#define 	Vk2c21B_MAXSEGNUM			12
//#define 	Vk2c21C_MAXSEGNUM			8
//#define 	Vk2c21D_MAXSEGNUM			4

//¹ܽøݿͻƬӦ޸ 
#define Vk2c21_SCL_PIN    BIT13
#define Vk2c21_SCL_PORT   PA
#define Vk2c21_SCL_IO     PA13

#define Vk2c21_SDA_PIN    BIT15
#define Vk2c21_SDA_PORT   PA
#define Vk2c21_SDA_IO     PA15

//¹ܽݿͻƬӦ޸
#define Vk2c21_SCL_H() 				Vk2c21_SCL_IO = 1 
#define Vk2c21_SCL_L() 				Vk2c21_SCL_IO = 0 

#define Vk2c21_SDA_H() 				Vk2c21_SDA_IO = 1 
#define Vk2c21_SDA_L() 				Vk2c21_SDA_IO = 0 

#define Vk2c21_GET_SDA() 			Vk2c21_SDA_IO
//ƬSDAΪIOҪΪ
//ݿͻƬ޸
#define Vk2c21_DIRDAT_PIN   	BIT0
#define Vk2c21_DIRDAT_PORT  	PB
#define Vk2c21_DIRDAT_IO    	PB0
#define Vk2c21_DIRDAT1_PIN   	BIT12
#define Vk2c21_DIRDAT1_PORT  	PA
#define Vk2c21_DIRDAT1_IO    	PA12
#define Vk2c21_SET_SDA_DIR() 	{\
	GPIO_SetMode(Vk2c21_DIRDAT_PORT, Vk2c21_DIRDAT_PIN, GPIO_MODE_OUTPUT);\
	GPIO_SetMode(Vk2c21_DIRDAT1_PORT, Vk2c21_DIRDAT1_PIN, GPIO_MODE_OUTPUT);\
}
#define Vk2c21_SET_SDA_IN() 	{\
  Vk2c21_DIRDAT_IO = 0;\
  Vk2c21_DIRDAT1_IO = 0;\
}
#define Vk2c21_SET_SDA_OUT() 	{\
 	Vk2c21_DIRDAT_IO = 1;\
  Vk2c21_DIRDAT1_IO = 1;\
}
/* Exported functions ------------------------------------------------------- */
void Vk2c21_Init(void);
void Vk2c21_DisAll(unsigned char dat);
void Vk2c21_DisSegComOn(unsigned char seg,unsigned char com);
void Vk2c21_DisSegComOff(unsigned char seg,unsigned char com);

void Vk2c21_Main(void);
#endif  /*__VK2c21_H*/

/************************END OF FILE****/
